import { SyncHook } from '@antv/async-hook';
import { IClusterOptions, IParserCfg, IParserData, ISourceCFG, ITransform } from '@antv/l7-core';
import { BBox } from '@turf/helpers';
import { EventEmitter } from 'eventemitter3';
export default class Source extends EventEmitter {
    data: IParserData;
    extent: BBox;
    hooks: {
        init: SyncHook;
    };
    parser: IParserCfg;
    transforms: ITransform[];
    cluster: boolean;
    clusterOptions: Partial<IClusterOptions>;
    private originData;
    private rawData;
    private clusterIndex;
    constructor(data: any, cfg?: ISourceCFG);
    setData(data: any): void;
    getClusters(zoom: number): any;
    getClustersLeaves(id: number): any;
    updateClusterData(zoom: number): void;
    getFeatureById(id: number): unknown;
    getFeatureId(field: string, value: any): number | undefined;
    private excuteParser;
    /**
     * 数据统计
     */
    private executeTrans;
    private initCluster;
    private init;
}
