"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  getTransform: true,
  registerTransform: true,
  getParser: true,
  registerParser: true
};
Object.defineProperty(exports, "getTransform", {
  enumerable: true,
  get: function get() {
    return _factory.getTransform;
  }
});
Object.defineProperty(exports, "registerTransform", {
  enumerable: true,
  get: function get() {
    return _factory.registerTransform;
  }
});
Object.defineProperty(exports, "getParser", {
  enumerable: true,
  get: function get() {
    return _factory.getParser;
  }
});
Object.defineProperty(exports, "registerParser", {
  enumerable: true,
  get: function get() {
    return _factory.registerParser;
  }
});
exports.default = void 0;

var _factory = require("./factory");

var _csv = _interopRequireDefault(require("./parser/csv"));

var _geojson = _interopRequireDefault(require("./parser/geojson"));

var _image = _interopRequireDefault(require("./parser/image"));

var _json = _interopRequireDefault(require("./parser/json"));

var _raster = _interopRequireDefault(require("./parser/raster"));

var _source = _interopRequireDefault(require("./source"));

var _cluster = require("./transform/cluster");

var _filter = require("./transform/filter");

var _grid = require("./transform/grid");

var _hexagon = require("./transform/hexagon");

var _join = require("./transform/join");

var _map = require("./transform/map");

var _interface = require("./interface");

Object.keys(_interface).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _interface[key];
    }
  });
});
var _default = _source.default;
exports.default = _default;
(0, _factory.registerParser)('geojson', _geojson.default);
(0, _factory.registerParser)('image', _image.default);
(0, _factory.registerParser)('csv', _csv.default);
(0, _factory.registerParser)('json', _json.default);
(0, _factory.registerParser)('raster', _raster.default);
(0, _factory.registerTransform)('cluster', _cluster.cluster);
(0, _factory.registerTransform)('filter', _filter.filter);
(0, _factory.registerTransform)('join', _join.join);
(0, _factory.registerTransform)('map', _map.map);
(0, _factory.registerTransform)('grid', _grid.aggregatorToGrid);
(0, _factory.registerTransform)('hexagon', _hexagon.pointToHexbin);
//# sourceMappingURL=index.js.map