"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _cloneDeep2 = _interopRequireDefault(require("lodash/cloneDeep"));

var _asyncHook = require("@antv/async-hook");

var _l7Utils = require("@antv/l7-utils");

var _eventemitter = require("eventemitter3");

var _supercluster = _interopRequireDefault(require("supercluster/dist/supercluster"));

var _ = require("./");

var _statistics = require("./utils/statistics");

var _util = require("./utils/util");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Source = function (_EventEmitter) {
  (0, _inherits2.default)(Source, _EventEmitter);

  function Source(data, cfg) {
    var _this;

    (0, _classCallCheck2.default)(this, Source);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Source).call(this));
    _this.data = void 0;
    _this.extent = void 0;
    _this.hooks = {
      init: new _asyncHook.SyncHook()
    };
    _this.parser = {
      type: 'geojson'
    };
    _this.transforms = [];
    _this.cluster = false;
    _this.clusterOptions = {
      enable: false,
      radius: 40,
      maxZoom: 20,
      zoom: -99,
      method: 'count'
    };
    _this.originData = void 0;
    _this.rawData = void 0;
    _this.clusterIndex = void 0;
    _this.rawData = (0, _cloneDeep2.default)(data);
    _this.originData = data;

    if (cfg) {
      if (cfg.parser) {
        _this.parser = cfg.parser;
      }

      if (cfg.transforms) {
        _this.transforms = cfg.transforms;
      }

      _this.cluster = cfg.cluster || false;

      if (cfg.clusterOptions) {
        _this.cluster = true;
        _this.clusterOptions = _objectSpread({}, _this.clusterOptions, {}, cfg.clusterOptions);
      }
    }

    _this.hooks.init.tap('parser', function () {
      _this.excuteParser();
    });

    _this.hooks.init.tap('cluster', function () {
      _this.initCluster();
    });

    _this.hooks.init.tap('transform', function () {
      _this.executeTrans();
    });

    _this.init();

    return _this;
  }

  (0, _createClass2.default)(Source, [{
    key: "setData",
    value: function setData(data) {
      this.rawData = data;
      this.originData = (0, _cloneDeep2.default)(data);
      this.init();
      this.emit('update');
    }
  }, {
    key: "getClusters",
    value: function getClusters(zoom) {
      return this.clusterIndex.getClusters(this.extent, zoom);
    }
  }, {
    key: "getClustersLeaves",
    value: function getClustersLeaves(id) {
      return this.clusterIndex.getLeaves(id, Infinity);
    }
  }, {
    key: "updateClusterData",
    value: function updateClusterData(zoom) {
      var _this2 = this;

      var _this$clusterOptions = this.clusterOptions,
          _this$clusterOptions$ = _this$clusterOptions.method,
          method = _this$clusterOptions$ === void 0 ? 'sum' : _this$clusterOptions$,
          field = _this$clusterOptions.field;
      var data = this.clusterIndex.getClusters(this.extent, zoom);
      this.clusterOptions.zoom = zoom;
      data.forEach(function (p) {
        if (!p.id) {
          p.properties.point_count = 1;
        }
      });

      if (field || (0, _isFunction2.default)(method)) {
        data = data.map(function (item) {
          var id = item.id;

          if (id) {
            var points = _this2.clusterIndex.getLeaves(id, Infinity);

            var properties = points.map(function (d) {
              return d.properties;
            });
            var statNum;

            if ((0, _isString2.default)(method) && field) {
              var column = (0, _util.getColumn)(properties, field);
              statNum = _statistics.statMap[method](column);
            }

            if ((0, _isFunction2.default)(method)) {
              statNum = method(properties);
            }

            item.properties.stat = statNum;
          } else {
            item.properties.point_count = 1;
          }

          return item;
        });
      }

      this.data = (0, _.getParser)('geojson')({
        type: 'FeatureCollection',
        features: data
      });
      this.executeTrans();
    }
  }, {
    key: "getFeatureById",
    value: function getFeatureById(id) {
      var _this$parser$type = this.parser.type,
          type = _this$parser$type === void 0 ? 'geojson' : _this$parser$type;

      if (type === 'geojson' && !this.cluster && this.transforms.length === 0) {
        return id < this.originData.features.length ? this.originData.features[id] : 'null';
      } else {
        return id < this.data.dataArray.length ? this.data.dataArray[id] : 'null';
      }
    }
  }, {
    key: "getFeatureId",
    value: function getFeatureId(field, value) {
      var feature = this.data.dataArray.find(function (dataItem) {
        return dataItem[field] === name;
      });
      return feature === null || feature === void 0 ? void 0 : feature._id;
    }
  }, {
    key: "excuteParser",
    value: function excuteParser() {
      var parser = this.parser;
      var type = parser.type || 'geojson';
      var sourceParser = (0, _.getParser)(type);
      this.data = sourceParser(this.originData, parser);
      this.extent = (0, _l7Utils.extent)(this.data.dataArray);
    }
  }, {
    key: "executeTrans",
    value: function executeTrans() {
      var _this3 = this;

      var trans = this.transforms;
      trans.forEach(function (tran) {
        var type = tran.type;
        var data = (0, _.getTransform)(type)(_this3.data, tran);
        Object.assign(_this3.data, data);
      });
    }
  }, {
    key: "initCluster",
    value: function initCluster() {
      if (!this.cluster) {
        return;
      }

      var _this$clusterOptions2 = this.clusterOptions,
          radius = _this$clusterOptions2.radius,
          _this$clusterOptions3 = _this$clusterOptions2.minZoom,
          minZoom = _this$clusterOptions3 === void 0 ? 0 : _this$clusterOptions3,
          maxZoom = _this$clusterOptions2.maxZoom;
      this.clusterIndex = new _supercluster.default({
        radius: radius,
        minZoom: minZoom,
        maxZoom: maxZoom
      });
      this.clusterIndex.load(this.rawData.features);
    }
  }, {
    key: "init",
    value: function init() {
      this.hooks.init.call(this);
    }
  }]);
  return Source;
}(_eventemitter.EventEmitter);

exports.default = Source;
//# sourceMappingURL=source.js.map